﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Charting;

namespace WindowsFormsApplication3
{
	public partial class Form1 : Form
	{
		Random r;
		DateTime now;
		int itemsCount = 20;
		public Form1()
		{
			InitializeComponent();
			r = new Random();
			InitChart();
			timer1.Interval = 5000;
			timer1.Start();
		}

		private void InitChart()
		{
			now = DateTime.Now;
			radChart1.Series.Clear();
			radChart1.AutoLayout = true;
			radChart1.PlotArea.XAxis.AutoScale = false;
			radChart1.PlotArea.XAxis.Appearance.ValueFormat = Telerik.Charting.Styles.ChartValueFormat.LongTime;
			radChart1.PlotArea.XAxis.LabelStep = 5;
			radChart1.PlotArea.XAxis.AddRange(0, itemsCount, 1);
			radChart1.PlotArea.XAxis.LayoutMode = Telerik.Charting.Styles.ChartAxisLayoutMode.Normal;
			ChartSeries ser = new ChartSeries("MySeries", ChartSeriesType.Line);
			ser.Appearance.LabelAppearance.Visible = false;
			ChartSeriesItem item;
			
			for (int i = 0; i < itemsCount + 1; i++)
			{
				item = new ChartSeriesItem(r.Next(30));
				item.XValue = i;
				ser.Items.Add(item);
			}
			radChart1.Series.Add(ser);
			radChart1.BeforeLayout += new EventHandler<EventArgs>(radChart1_BeforeLayout);
		}

		void radChart1_BeforeLayout(object sender, EventArgs e)
		{
			UpdateAxis(DateTime.Now);
		}

		private void UpdateAxis(DateTime now)
		{
			DateTime start = now.AddSeconds(-itemsCount * 5);
			for (int i = 0; i < radChart1.PlotArea.XAxis.Items.Count; i++)
			{
				radChart1.PlotArea.XAxis.Items[i].TextBlock.Text = start.AddSeconds(i * 5).ToString("hh:mm:ss");
			}
		}

		private void timer1_Tick(object sender, EventArgs e)
		{
			radChart1.Series[0].Items.RemoveAt(0);
			foreach (var chartSeriesItem in radChart1.Series[0].Items)
			{
				chartSeriesItem.XValue--;
			}
			ChartSeriesItem newItem = new ChartSeriesItem(r.Next(30));
			newItem.XValue = itemsCount;
			radChart1.Series[0].Items.Add(newItem);
			radChart1.UpdateGraphics();
		}
	}
}
